DECLARE SUB dcls ()
DECLARE SUB dlocate (r%, c%)
DECLARE SUB shutdown ()
DECLARE SUB checkcarrier ()
DECLARE FUNCTION dinkey$ ()
DECLARE SUB dprint (st$)
'*****************************************************************************
'* SKELETON.BAS - Online Game Skeleton for use with QuickBasic 4.5 and       *
'* QBSERIAL 1.x or 2.x.                                                      *
'* Thanks to Jeff Sumberg for writing QBSerial, it is the best door interface*
'* I have ever seen.                                                         *
'* This file may be freely distributed and modified as long as this message  *
'* is intact. Please note any modifications you have made before you         *
'* distribute this file.                                                     *
'*                                                                           *
'* If you have any problems or questions I'll be happy to help. E-mail       *
'* 1 @19960 WWIVnet, or call Test Site BBS (plug plug plug) at [919]760-4811,*
'* 1200/2400/4800/7200/9600/12000/14400 v.32 v.32bis v.42 v.42bis MNP2-5 LAPM*
'* (deep breath) and more!                                                   *
'*                                                                           *
'*****************************************************************************
'*                                                                           *
'* QBSerial V3.0 and non-standard CHAIN.TXT modifications made by            *
'* Wayne "The Mad Hatter" Borean 1@4651 WWIVNet. For more information call   *
'* Through the Looking Glass, 416-567-0366 (will change to area code 905 in  *
'* October 1993. These modifications were made June 8, 1993. As noted above  *
'* this file may be freely distributed as long as these notices remain       *
'* intact. Further modifications will be welcomed, keep this file in updated *                                                                   
'* and please feel free to send copies to me. Also, I keep about 13 meg of   *
'* QB45 files on-line.                                                       *
'*                                                                           *
'*****************************************************************************
'
'Sub functions and how to call them:
'
'DPRINT string$ - Send a string to the modem and the console. If you put a ;
'at the end of the STRING, it will not put a CR/LF (carriage return) on the
'end. Example:
'
'DPRINT "This is a test."
'would output:
'This is a test.
'
'DPRINT "This is another test;"
'DPRINT " This is on the same line."
'would output:
'This is another test This is on the same line.
'
'DCLS - Clears remote and local screen. No parameters, just use DCLS.
'
'DCOLOR foreground%, background% - Change colors of remote and local screen.
'Same format as QB's COLOR statement, and it uses the same colors. See your
'QB manual for a list of colors.
'
'DINKEY$ - Same as QB's INKEY$ statement except it will WAIT for a key to be
'pressed instead of you having to use a DO...LOOP to wait for a keystroke.
'And of course it works remotely, just like all the other routines in this
'program.
'
'Usage:
'choice$ = dinkey$
'
'DINPUT prompt$, inputstr$, maxlen% - Input a string. For example:
'
'DINPUT "What's your name? ", username$, 40
'This would prompt the user with "What's your name?". His response would be
'contained in the variable username$, and it would not allow the user to input
'more than 40 characters. If you want to input numbers, you will have to use
'the VAL statement, such as:
'
'DINPUT "What's your age? ", temp$, 2
'userage% = VAL(temp$)
'
'DLOCATE row%, col% - Locate cursor on local and remote screen. Format is the
'same as QB's LOCATE command, except for the cursor size and cursor
'hidden/showing part.
'
'SHUTDOWN - No parameters.. Just call SHUTDOWN when you are ready to end your
'program. You may want to modify this routine to save the user's info, because
'if carrier is lost, program control will automatically branch to this
'routine.
'
'That's all of the routines I included in here. Everything else should work
'fine. Just put your code where it says "Put your code here" and make sure you
'are using the correct OpenComm string for your version of QBSERIAL as noted
'below.
'*****************************************************************************
'
'You will need the QBSERIAL.DEC file that came with QBSERIAL to use this..
'
'$INCLUDE: 'qbserial.dec'
'
'Make all information about the user global, i.e. available to the whole
'program.
COMMON SHARED kb%, addr%, usernum%, username$, ansi%, gfilesdir$, datadir$
COMMON SHARED logname$, seclev%, cosysop%, sysop%, bbsname$, sysopname$
COMMON SHARED userrealname$, usercall$, age%, sex$, gold#, lastlogon$, columns%
COMMON SHARED wide%, location%, timeleft!, Port%, timeloggedon!, timeonsofar!
COMMON SHARED Parity$, uloadk&, numul&, dloadk&, numdl&, baudrate&
      DIM descript$(5)

'
'Now to open up WWIV's CHAIN.TXT file and get info about the user and the
'modem..
'
'Note: Many WWIV BBS's do not reside in C:\WWIV. I recommend commenting out
'the first "IF COMMAND$" line and using the second. TMH
'
IF COMMAND$ = "" THEN com$ = "C:\WWIV\CHAIN.TXT" ELSE com$ = COMMAND$
'IF COMMAND$ = "" THEN CLS : LOCATE 12, 20: PRINT "PLEASE TELL ME WHERE CHAIN.TXT IS!": shutdown


OPEN com$ FOR INPUT AS #1
INPUT #1, usernum%                   'User number
INPUT #1, username$                  'User alias
INPUT #1, userrealname$              'User real name
INPUT #1, usercall$                  'User callsign (HAM radio)
INPUT #1, age%                       'User age
INPUT #1, sex$                       'User sex
INPUT #1, gold#                      'User gold
INPUT #1, lastlogon$                 'User last logon date
INPUT #1, columns%                   'User colums
INPUT #1, wide%                      'User width
INPUT #1, seclev%                    'User security level (0-255)
INPUT #1, cosysop%                   '1 if Co-SysOp, 0 if not
INPUT #1, sysop%                     '1 if SysOp, 0 if not
INPUT #1, ansi%                      '1 if ANSI, 0 if not
INPUT #1, location%                  '1 if at remote, 0 if local console
INPUT #1, timeleft!                  'User number of seconds left till logoff
INPUT #1, gfilesdir$                 'System GFILES directory (gen. txt files)
INPUT #1, datadir$                   'System DATA directory
INPUT #1, logname$                   'System log of the day
INPUT #1, b$                         'User baud rate
INPUT #1, Port%                      'System com port
INPUT #1, bbsname$                   'System name
INPUT #1, sysopname$                 'System SysOp
INPUT #1, timeloggedon!              'Time user logged on/# of secs. from midn.
INPUT #1, timeonsofar!               'User number of seconds on system so far
INPUT #1, uloadk&                    'User number of uploaded k
INPUT #1, numul&                     'User number of uploads
INPUT #1, dloadk&                    'User amount of downloaded k
INPUT #1, numdl&                     'User number of downloads
INPUT #1, Parity$                    'User parity
CLOSE #1
IF VAL(b$) = 0 OR UCASE$(b$) = "KB" THEN baudrate& = 0 ELSE baudrate& = VAL(b$)
SELECT CASE Port%
   CASE 0: REM - for local operations
   CASE 1: addr% = &H3F8
   CASE 2: addr% = &H2F8
   CASE 3: addr% = &H3FE
   CASE 4: addr% = &H2FE
   CASE ELSE: PRINT "Must run on COM1-4."
END SELECT
IF baudrate& = 0 THEN Port% = 0: kb% = 1 ELSE kb% = 0
'
'NOTE: If you are using QBSERIAL 2.0, comment out the first OpenComm line
'and use the second one! If you are running 1.x, the way it is set up
'now should work.
'
'Additional Note: The third OpenComm line is for QBSerial 3.0, if you are
'using it comment out the other OpenComm lines. Pardon if this doesn't make
'a lot of sense, once again I am just about asleep at the keyboard. I do
'recommend that you get QBSerial 3.0 if you are using an earlier version.

'For QBSerial 1.x
OpenComm Port%, 0, 0, 0, 3

'For QBSerial 2.x
'OpenComm Port%, 0, 0, 0, 3, 0,

'For QBSerrial 3.x
'OpenComm Port%, 0, 0, 0, 3, 0, 0

'------------------------------------- Put your code here...





'------------------------------------- Your code ends here...
shutdown

SUB checkcarrier

IF kb% = 1 THEN EXIT SUB

IF INP(addr% + 6) < &H80 THEN
   CloseComm
   END
END IF
END SUB

SUB dcls
IF ansi% = 0 THEN EXIT SUB
CLS 2
Transmit CHR$(27) + "[2J"
END SUB

SUB dcolor (fg%, bg%)
IF ansi% = 0 THEN EXIT SUB
COLOR fg%, bg%
Transmit CHR$(27) + "[0m"
IF fg% > 16 THEN
   Transmit CHR$(27) + "[5m"
   fg% = fg% - 16
END IF
IF fg% > 7 THEN
   Transmit CHR$(27) + "[1m"
   fg% = fg% - 7
END IF

SELECT CASE fg%
   CASE 0
      Transmit CHR$(27) + "[30m"
   CASE 1
      Transmit CHR$(27) + "[34m"
   CASE 2
      Transmit CHR$(27) + "[32m"
   CASE 3
      Transmit CHR$(27) + "[36m"
   CASE 4
      Transmit CHR$(27) + "[31m"
   CASE 5
      Transmit CHR$(27) + "[35m"
   CASE 6
      Transmit CHR$(27) + "[33m"
   CASE 7
      Transmit CHR$(27) + "[37m"
   CASE ELSE
END SELECT

SELECT CASE bg%
   CASE 0
      Transmit CHR$(27) + "[40m"
   CASE 1
      Transmit CHR$(27) + "[44m"
   CASE 2
      Transmit CHR$(27) + "[42m"
   CASE 3
      Transmit CHR$(27) + "[46m"
   CASE 4
      Transmit CHR$(27) + "[41m"
   CASE 5
      Transmit CHR$(27) + "[45m"
   CASE 6
      Transmit CHR$(27) + "[43m"
   CASE 7
      Transmit CHR$(27) + "[47m"
   CASE ELSE
END SELECT

END SUB

FUNCTION dinkey$
   DO
      checkcarrier
      k1$ = INKEY$
      kk2% = ReadChar%
         IF kk2% > 0 THEN
            k2$ = CHR$(kk2%)
         END IF
   LOOP UNTIL k1$ <> "" OR k2$ <> ""
IF k1$ <> "" THEN
   dinkey$ = k1$
ELSE
   dinkey$ = k2$
END IF
END FUNCTION

SUB dinput (pr$, st$, maxlen%)
st$ = ""
dprint pr$ + " ;"
DO
   IF maxlen% < 0 THEN
      n$ = UCASE$(dinkey$)
   ELSE
      n$ = dinkey$
   END IF
   SELECT CASE n$
      CASE CHR$(13)
         dprint ""
         EXIT SUB
      CASE CHR$(8)
         IF LEN(st$) > 0 THEN
            lc% = POS(0) - 1
            LOCATE , lc%
            PRINT " ";
            LOCATE , lc%
            st$ = LEFT$(st$, LEN(st$) - 1)
            Transmit ""
         ELSE
            Transmit ""
         END IF
      CASE ELSE:
         IF ABS(maxlen%) > LEN(st$) THEN
            st$ = st$ + n$
            PRINT n$;
            Transmit n$
         ELSE
            Transmit ""
         END IF
   END SELECT
LOOP

END SUB

SUB dlocate (r%, c%)
LOCATE r%, c%
Transmit CHR$(27) + "[" + LTRIM$(STR$(r%)) + ";" + LTRIM$(STR$(c%)) + "H"
END SUB

SUB dprint (st$)
   IF RIGHT$(st$, 1) = ";" THEN
      Transmit LEFT$(st$, LEN(st$) - 1)
      PRINT LEFT$(st$, LEN(st$) - 1);
   ELSE
      Transmit st$ + CHR$(13) + CHR$(10)
      PRINT st$
   END IF
END SUB

SUB shutdown
CloseComm
END
END SUB

